# class OpenSSL::Engine

This class is the access to openssl’s ENGINE cryptographic module implementation.

See also, www.openssl.org/docs/crypto/engine.html

### Public Class Methods

OpenSSL::Engine.by_id(name) → engine
Source

    static VALUE
    ossl_engine_s_by_id(VALUE klass, VALUE id)
    {
        ENGINE *e;
        VALUE obj;

        StringValueCStr(id);
        ossl_engine_s_load(1, &id, klass);
        obj = NewEngine(klass);
        if(!(e = ENGINE_by_id(RSTRING_PTR(id))))
            ossl_raise(eEngineError, NULL);
        SetEngine(obj, e);
        if(rb_block_given_p()) rb_yield(obj);
        if(!ENGINE_init(e))
            ossl_raise(eEngineError, NULL);
        ENGINE_ctrl(e, ENGINE_CTRL_SET_PASSWORD_CALLBACK,
                    0, NULL, (void(*)(void))ossl_pem_passwd_cb);
        ossl_clear_error();

        return obj;
    }

Fetches the engine as specified by the id `String`.

    OpenSSL::Engine.by_id("openssl")
     => #<OpenSSL::Engine id="openssl" name="Software engine support">

See `OpenSSL::Engine.engines` for the currently loaded engines.

OpenSSL::Engine.cleanup
Source

    static VALUE
    ossl_engine_s_cleanup(VALUE self)
    {
    #if defined(LIBRESSL_VERSION_NUMBER) || OPENSSL_VERSION_NUMBER < 0x10100000
        ENGINE_cleanup();
    #endif
        return Qnil;
    }

It is only necessary to run cleanup when engines are loaded via `OpenSSL::Engine.load`. However, running cleanup before exit is recommended.

Note that this is needed and works only in `OpenSSL` < 1.1.0.

OpenSSL::Engine.engines → [engine, ...]
Source

    static VALUE
    ossl_engine_s_engines(VALUE klass)
    {
        ENGINE *e;
        VALUE ary, obj;

        ary = rb_ary_new();
        for(e = ENGINE_get_first(); e; e = ENGINE_get_next(e)){
            obj = NewEngine(klass);
            /* Need a ref count of two here because of ENGINE_free being
             * called internally by OpenSSL when moving to the next ENGINE
             * and by us when releasing the ENGINE reference */
            ENGINE_up_ref(e);
            SetEngine(obj, e);
            rb_ary_push(ary, obj);
        }

        return ary;
    }

Returns an array of currently loaded engines.

OpenSSL::Engine.load(name = nil)
Source

    static VALUE
    ossl_engine_s_load(int argc, VALUE *argv, VALUE klass)
    {
        VALUE name;

        rb_scan_args(argc, argv, "01", &name);
        if(NIL_P(name)){
            ENGINE_load_builtin_engines();
            return Qtrue;
        }
        StringValueCStr(name);
    #ifdef HAVE_ENGINE_LOAD_DYNAMIC
        OSSL_ENGINE_LOAD_IF_MATCH(dynamic, DYNAMIC);
    #endif
    #ifndef OPENSSL_NO_STATIC_ENGINE
    #ifdef HAVE_ENGINE_LOAD_4758CCA
        OSSL_ENGINE_LOAD_IF_MATCH(4758cca, 4758CCA);
    #endif
    #ifdef HAVE_ENGINE_LOAD_AEP
        OSSL_ENGINE_LOAD_IF_MATCH(aep, AEP);
    #endif
    #ifdef HAVE_ENGINE_LOAD_ATALLA
        OSSL_ENGINE_LOAD_IF_MATCH(atalla, ATALLA);
    #endif
    #ifdef HAVE_ENGINE_LOAD_CHIL
        OSSL_ENGINE_LOAD_IF_MATCH(chil, CHIL);
    #endif
    #ifdef HAVE_ENGINE_LOAD_CSWIFT
        OSSL_ENGINE_LOAD_IF_MATCH(cswift, CSWIFT);
    #endif
    #ifdef HAVE_ENGINE_LOAD_NURON
        OSSL_ENGINE_LOAD_IF_MATCH(nuron, NURON);
    #endif
    #ifdef HAVE_ENGINE_LOAD_SUREWARE
        OSSL_ENGINE_LOAD_IF_MATCH(sureware, SUREWARE);
    #endif
    #ifdef HAVE_ENGINE_LOAD_UBSEC
        OSSL_ENGINE_LOAD_IF_MATCH(ubsec, UBSEC);
    #endif
    #ifdef HAVE_ENGINE_LOAD_PADLOCK
        OSSL_ENGINE_LOAD_IF_MATCH(padlock, PADLOCK);
    #endif
    #ifdef HAVE_ENGINE_LOAD_CAPI
        OSSL_ENGINE_LOAD_IF_MATCH(capi, CAPI);
    #endif
    #ifdef HAVE_ENGINE_LOAD_GMP
        OSSL_ENGINE_LOAD_IF_MATCH(gmp, GMP);
    #endif
    #ifdef HAVE_ENGINE_LOAD_GOST
        OSSL_ENGINE_LOAD_IF_MATCH(gost, GOST);
    #endif
    #endif
    #ifdef HAVE_ENGINE_LOAD_CRYPTODEV
        OSSL_ENGINE_LOAD_IF_MATCH(cryptodev, CRYPTODEV);
    #endif
        OSSL_ENGINE_LOAD_IF_MATCH(openssl, OPENSSL);
        rb_warning("no such builtin loader for `%"PRIsVALUE"'", name);
        return Qnil;
    }

This method loads engines. If name is nil, then all builtin engines are loaded. Otherwise, the given name, as a `String`, is loaded if available to your runtime, and returns true. If name is not found, then nil is returned.

### Public Instance Methods

cipher(name) → OpenSSL::Cipher
Source

    static VALUE
    ossl_engine_get_cipher(VALUE self, VALUE name)
    {
        ENGINE *e;
        const EVP_CIPHER *ciph, *tmp;
        int nid;

        tmp = EVP_get_cipherbyname(StringValueCStr(name));
        if(!tmp) ossl_raise(eEngineError, "no such cipher `%"PRIsVALUE"'", name);
        nid = EVP_CIPHER_nid(tmp);
        GetEngine(self, e);
        ciph = ENGINE_get_cipher(e, nid);
        if(!ciph) ossl_raise(eEngineError, NULL);

        return ossl_cipher_new(ciph);
    }

Returns a new instance of `OpenSSL::Cipher` by name, if it is available in this engine.

An `EngineError` will be raised if the cipher is unavailable.

    e = OpenSSL::Engine.by_id("openssl")
     => #<OpenSSL::Engine id="openssl" name="Software engine support">
    e.cipher("RC4")
     => #<OpenSSL::Cipher:0x007fc5cacc3048>

cmds → [["name", "description", "flags"], ...]
Source

    static VALUE
    ossl_engine_get_cmds(VALUE self)
    {
        ENGINE *e;
        const ENGINE_CMD_DEFN *defn, *p;
        VALUE ary, tmp;

        GetEngine(self, e);
        ary = rb_ary_new();
        if ((defn = ENGINE_get_cmd_defns(e)) != NULL){
            for (p = defn; p->cmd_num > 0; p++){
                tmp = rb_ary_new();
                rb_ary_push(tmp, rb_str_new2(p->cmd_name));
                rb_ary_push(tmp, rb_str_new2(p->cmd_desc));
                rb_ary_push(tmp, ossl_engine_cmd_flag_to_name(p->cmd_flags));
                rb_ary_push(ary, tmp);
            }
        }

        return ary;
    }

Returns an array of command definitions for the current engine

ctrl_cmd(command, value = nil) → engine
Source

    static VALUE
    ossl_engine_ctrl_cmd(int argc, VALUE *argv, VALUE self)
    {
        ENGINE *e;
        VALUE cmd, val;
        int ret;

        GetEngine(self, e);
        rb_scan_args(argc, argv, "11", &cmd, &val);
        ret = ENGINE_ctrl_cmd_string(e, StringValueCStr(cmd),
                                     NIL_P(val) ? NULL : StringValueCStr(val), 0);
        if (!ret) ossl_raise(eEngineError, NULL);

        return self;
    }

Sends the given command to this engine.

Raises an `EngineError` if the command fails.

digest(name) → OpenSSL::Digest
Source

    static VALUE
    ossl_engine_get_digest(VALUE self, VALUE name)
    {
        ENGINE *e;
        const EVP_MD *md, *tmp;
        int nid;

        tmp = EVP_get_digestbyname(StringValueCStr(name));
        if(!tmp) ossl_raise(eEngineError, "no such digest `%"PRIsVALUE"'", name);
        nid = EVP_MD_nid(tmp);
        GetEngine(self, e);
        md = ENGINE_get_digest(e, nid);
        if(!md) ossl_raise(eEngineError, NULL);

        return ossl_digest_new(md);
    }

Returns a new instance of `OpenSSL::Digest` by name.

Will raise an `EngineError` if the digest is unavailable.

    e = OpenSSL::Engine.by_id("openssl")
      #=> #<OpenSSL::Engine id="openssl" name="Software engine support">
    e.digest("SHA1")
      #=> #<OpenSSL::Digest: da39a3ee5e6b4b0d3255bfef95601890afd80709>
    e.digest("zomg")
      #=> OpenSSL::Engine::EngineError: no such digest `zomg'

finish → nil
Source

    static VALUE
    ossl_engine_finish(VALUE self)
    {
        ENGINE *e;

        GetEngine(self, e);
        if(!ENGINE_finish(e)) ossl_raise(eEngineError, NULL);

        return Qnil;
    }

Releases all internal structural references for this engine.

May raise an `EngineError` if the engine is unavailable

id → string
Source

    static VALUE
    ossl_engine_get_id(VALUE self)
    {
        ENGINE *e;
        GetEngine(self, e);
        return rb_str_new2(ENGINE_get_id(e));
    }

Gets the id for this engine.

    OpenSSL::Engine.load
    OpenSSL::Engine.engines #=> [#<OpenSSL::Engine#>, ...]
    OpenSSL::Engine.engines.first.id
      #=> "rsax"

inspect → string
Source

    static VALUE
    ossl_engine_inspect(VALUE self)
    {
        ENGINE *e;

        GetEngine(self, e);
        return rb_sprintf("#<%"PRIsVALUE" id=\"%s\" name=\"%s\">",
                          rb_obj_class(self), ENGINE_get_id(e), ENGINE_get_name(e));
    }

Pretty prints this engine.

load_private_key(id = nil, data = nil) → OpenSSL::PKey
Source

    static VALUE
    ossl_engine_load_privkey(int argc, VALUE *argv, VALUE self)
    {
        ENGINE *e;
        EVP_PKEY *pkey;
        VALUE id, data, obj;
        char *sid, *sdata;

        rb_scan_args(argc, argv, "02", &id, &data);
        sid = NIL_P(id) ? NULL : StringValueCStr(id);
        sdata = NIL_P(data) ? NULL : StringValueCStr(data);
        GetEngine(self, e);
        pkey = ENGINE_load_private_key(e, sid, NULL, sdata);
        if (!pkey) ossl_raise(eEngineError, NULL);
        obj = ossl_pkey_new(pkey);
        OSSL_PKEY_SET_PRIVATE(obj);

        return obj;
    }

Loads the given private key identified by id and data.

An `EngineError` is raised of the `OpenSSL::PKey` is unavailable.

load_public_key(id = nil, data = nil) → OpenSSL::PKey
Source

    static VALUE
    ossl_engine_load_pubkey(int argc, VALUE *argv, VALUE self)
    {
        ENGINE *e;
        EVP_PKEY *pkey;
        VALUE id, data;
        char *sid, *sdata;

        rb_scan_args(argc, argv, "02", &id, &data);
        sid = NIL_P(id) ? NULL : StringValueCStr(id);
        sdata = NIL_P(data) ? NULL : StringValueCStr(data);
        GetEngine(self, e);
        pkey = ENGINE_load_public_key(e, sid, NULL, sdata);
        if (!pkey) ossl_raise(eEngineError, NULL);

        return ossl_pkey_new(pkey);
    }

Loads the given public key identified by id and data.

An `EngineError` is raised of the `OpenSSL::PKey` is unavailable.

name → string
Source

    static VALUE
    ossl_engine_get_name(VALUE self)
    {
        ENGINE *e;
        GetEngine(self, e);
        return rb_str_new2(ENGINE_get_name(e));
    }

Get the descriptive name for this engine.

    OpenSSL::Engine.load
    OpenSSL::Engine.engines #=> [#<OpenSSL::Engine#>, ...]
    OpenSSL::Engine.engines.first.name
      #=> "RSAX engine support"

set_default(flag)
Source

    static VALUE
    ossl_engine_set_default(VALUE self, VALUE flag)
    {
        ENGINE *e;
        int f = NUM2INT(flag);

        GetEngine(self, e);
        ENGINE_set_default(e, f);

        return Qtrue;
    }

`Set` the defaults for this engine with the given flag.

These flags are used to control combinations of algorithm methods.

flag can be one of the following, other flags are available depending on your OS.

All flags

  0xFFFF

No flags

  0x0000

See also <openssl/engine.h>